//
//  AppDelegate.m
//  SDKTestApp
//
//  Created by Vidyalaxmi V Shenoy on 20/07/15.
//  Copyright (c) 2015 Webaroo. All rights reserved.
//

#import "AppDelegate.h"
#import <TeamchatSDK/TeamchatSDK.h>
#import "NSData+Additions.h"

@interface AppDelegate ()

@end

@implementation AppDelegate


- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    // Override point for customization after application launch.

    NSLog(@"TeamchatSDK Version: %f \n %s",TeamchatSDKVersionNumber,TeamchatSDKVersionString);
    [Teamchat initializeWithAppID:@"122" withCompletionHanlder:^(BOOL success, NSError *error) {
        if (!success)
        {
           [[[UIAlertView alloc] initWithTitle:@"Failed" message:[error localizedDescription] delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil, nil] show];
        }
    }];
    
#ifdef __IPHONE_8_0
    //register to receive notifications
    //Referred http://stackoverflow.com/a/25301879/1029360 to fix a linker error when compiling on iOS 7.1
    if(NSFoundationVersionNumber > NSFoundationVersionNumber_iOS_7_1)
    {
        if ([application respondsToSelector:@selector(registerUserNotificationSettings:)]) //IOS 8
        {
            UIUserNotificationSettings *settings = [UIUserNotificationSettings settingsForTypes:(UIRemoteNotificationTypeBadge
                                                                                                 |UIRemoteNotificationTypeSound
                                                                                                 |UIRemoteNotificationTypeAlert) categories:nil];
            [application registerUserNotificationSettings:settings];
        }
    }
    else
#endif
    {
        UIRemoteNotificationType myTypes = UIRemoteNotificationTypeBadge | UIRemoteNotificationTypeAlert | UIRemoteNotificationTypeSound;
        [application registerForRemoteNotificationTypes:myTypes];
    }
    
    [self resetApplicationBadgeNumber];

    return YES;
}

#ifdef __IPHONE_8_0
- (void)application:(UIApplication *)application didRegisterUserNotificationSettings:(UIUserNotificationSettings *)notificationSettings
{
    [application registerForRemoteNotifications];
}
#endif

- (void)application:(UIApplication *)application didRegisterForRemoteNotificationsWithDeviceToken:(NSData *)deviceToken
{
    NSString *deviceTokenString = [deviceToken hexRepresentation];
    if (deviceTokenString.length == 0)
    {
        deviceTokenString = @"";
    }
    [Teamchat setRemoteNotificationsDeviceToken:deviceTokenString];
}

- (void)application:(UIApplication *)application didFailToRegisterForRemoteNotificationsWithError:(NSError *)error
{
    NSLog(@"DidFailToRegisterForRemoteNotificationsWithError - %@", [error localizedDescription]);
}

- (void)resetApplicationBadgeNumber
{
    if ([self canChangeBadge])
    {
        [UIApplication sharedApplication].applicationIconBadgeNumber = 0;
    }
}

- (BOOL)canChangeBadge
{
#ifdef __IPHONE_8_0
    if ([[UIApplication sharedApplication] respondsToSelector:@selector(currentUserNotificationSettings)]) //IOS 8
    {
        UIUserNotificationSettings* notificationSettings = [[UIApplication sharedApplication] currentUserNotificationSettings];
        return notificationSettings.types & UIUserNotificationTypeBadge;
    }
#endif
    return YES;
}

- (void)application:(UIApplication *)application didReceiveRemoteNotification:(NSDictionary *)userInfo
{
    [self resetApplicationBadgeNumber];
}

- (void)applicationDidBecomeActive:(UIApplication *)application;
{
    [self resetApplicationBadgeNumber];
}

@end
