//
//  CustomContactTableViewCell.m
//  SDKTestApp
//
//  Created by Vidyalaxmi V Shenoy on 26/08/15.
//  Copyright (c) 2015 Robosoft. All rights reserved.
//

#import "CustomContactTableViewCell.h"
#import <TeamchatSDK/TeamchatSDK.h>

@interface CustomContactTableViewCell ()

@property (weak, nonatomic) IBOutlet UILabel *nameLabel;
@property (weak, nonatomic) IBOutlet UILabel *emailLabel;
@property (weak, nonatomic) IBOutlet UILabel *phoneLabel;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *emailLabelHeightConstraint;
@property (weak, nonatomic) IBOutlet NSLayoutConstraint *phoneLabelHeightConstraint;

@end

@implementation CustomContactTableViewCell

- (void)configureWithName:(NSString *)name email:(NSString *)email phone:(NSString *)phone
{
    self.nameLabel.text = [self.nameLabel.text stringByAppendingString:name];
    
    if (!email.length)
    {
        self.emailLabel.hidden = YES;
        self.emailLabelHeightConstraint.constant = 0;
    }
    else
    {
        self.emailLabel.text = [self.emailLabel.text stringByAppendingString:email];
    }
    
    if (!phone.length)
    {
        self.phoneLabel.hidden = YES;
        self.phoneLabelHeightConstraint.constant = 0;
    }
    else
    {
        self.phoneLabel.text = [self.phoneLabel.text stringByAppendingString:phone];
    }
}

+ (CGFloat)heightForContact:(TCTeamchatContact *)contact
{
    if (contact.email.length && contact.phone.length)
    {
        return 94.f;
    }
    else
    {
        return 67.f;
    }
}

@end
